VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmBackup 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Librarius 2000 : Backup"
   ClientHeight    =   1680
   ClientLeft      =   1410
   ClientTop       =   2835
   ClientWidth     =   6270
   HelpContextID   =   83100
   Icon            =   "BACKUP.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1680
   ScaleWidth      =   6270
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4815
      TabIndex        =   4
      Top             =   855
      Width           =   1230
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2655
      TabIndex        =   3
      Top             =   855
      Width           =   1230
   End
   Begin VB.CommandButton cmdBackup 
      Caption         =   "Backup"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   270
      TabIndex        =   2
      Top             =   855
      Width           =   1230
   End
   Begin VB.TextBox txtBackup_path 
      Height          =   330
      Left            =   1575
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   225
      Width           =   4380
   End
   Begin MSComDlg.CommonDialog MyDialogue 
      Left            =   1845
      Top             =   765
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label pnlProgress 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Starting Up ...."
      Height          =   285
      Left            =   45
      TabIndex        =   5
      Top             =   1350
      Width           =   6225
   End
   Begin VB.Label Label1 
      Caption         =   "Backup to"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   180
      TabIndex        =   0
      Top             =   270
      Width           =   1230
   End
End
Attribute VB_Name = "frmBackup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Loading As Boolean
Private Quotes As String * 1

Private Catalogue As Recordset
Private Catalogue_table As TableDef
Private Backup_file As Database
Private Catalogue_index As Index


Private Sub cmdBackup_Click()
    On Local Error GoTo Error_handler
    Dim DB_Path As String
    DB_Path = Trim(txtBackup_path.Text)
    
    If DB_Path = "" Then
        MsgBox "Enter backup path", vbExclamation, "Backup"
        Exit Sub
    Else
        If Not Ensure_that_db_is_not_required_by_Libra(DB_Path) Then GoTo Exit_proceedure
        If Not Path_valid(DB_Path) Then GoTo Exit_proceedure
        If Not Create_destination(DB_Path) Then GoTo Exit_proceedure
        If Not Tables_copied_successfully(DB_Path) Then GoTo Exit_proceedure
        If Not Catalogue_built(DB_Path) Then GoTo Exit_proceedure
        msg$ = "Backup completed successfully"
        pnlProgress.Caption = msg$
        MsgBox msg$, vbInformation, "Backup"
    End If
    
Exit Sub

Exit_proceedure:
    pnlProgress.Caption = "Backup unsuccessful. Please start over or exit by choosing Close."
    Exit Sub
Return
    


Error_handler:
    Response = MsgBox(Err.description, vbExclamation + vbRetryCancel, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume
        
    
End Sub

Private Sub cmdClose_Click()
    On Local Error GoTo Error_handler
    Unload Me
    
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbExclamation + vbExclamation + vbRetryCancel, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub

Private Sub cmdHelp_Click()
    Show_help (83100)
End Sub

Private Sub Form_Activate()
    On Local Error GoTo Error_handler
    If Loading Then
        Set HelpDialogue = MyDialogue
        App.HelpFile = App.Path + "\libra.hlp"
        Set MyWorkspace = DBEngine.Workspaces(0)
        Set Libra = MyWorkspace.OpenDatabase _
             (Get_ini_data("Libra_db_path"), True)
        Set Transaction_db = MyWorkspace.OpenDatabase _
             (Get_ini_data("Transac_db_path"), True)
        Set Setup = Libra.OpenRecordset("setup table")
        Set User_log = Transaction_db.OpenRecordset("user's log")
        Quotes = Chr(34)
        
        Load frmEnter_password
        With frmEnter_password
            .Top = Me.Top + (Me.Height / 2) - (.Height / 2)
            .Left = Me.Left + (Me.Width / 2) - (.Width / 2)
        End With
        
        Check_security
        Initialise_security
        If Allow_Backup Then
            Log_in_user (Area_Backup)
        Else
            msg$ = "You are not authorised to use this backup utility."
            MsgBox msg$, vbCritical, "Security Violation"
            End
        End If
        Loading = False
        
        pnlProgress.Caption = "Waiting for the name of the backup file"
    End If
    
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbExclamation + vbExclamation + vbRetryCancel, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume
        
End Sub

Private Sub Form_Load()
    On Local Error GoTo Error_handler
    
    If App.PrevInstance Then
        msg$ = "Another copy of Backup is already running."
        MsgBox msg$, vbCritical, "Backup"
        End
    Else
        Loading = True
    End If
    
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbExclamation + vbExclamation + vbRetryCancel, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Local Error GoTo Error_handler
    If Not (Loading) Then
        Log_out_user
    End If
    End
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbExclamation + vbExclamation + vbRetryCancel, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub




Private Sub txtBackup_path_Click()
    On Local Error GoTo Error_handler
    With MyDialogue
        .DialogTitle = "Backup Database To:"
        .Filter = "Databases (*.mdb)|*.mdb"
        .Flags = cdlOFNPathMustExist + cdlOFNHideReadOnly + cdlOFNOverwritePrompt + cdlOFNNoReadOnlyReturn
        .FileName = txtBackup_path.Text
        .CancelError = True
        .ShowSave
    End With
        
    txtBackup_path.Text = MyDialogue.FileName
    
Exit Sub

Error_handler:
    If Err.Number = cdlCancel Then
        Exit Sub
    Else
        Response = MsgBox(Err.description, vbExclamation + vbExclamation + vbRetryCancel, "Error")
        If Response = vbRetry Then
            Resume
        Else
            Exit Sub
        End If
    End If
Resume

End Sub

Private Function Path_valid(DB_Path As String) As Boolean
    pnlProgress.Caption = "Validating destination path..."
    If Dir(DB_Path) <> "" Then
        msg$ = "A database by the same name already exists. Are you "
        msg$ = msg$ + "sure you REALLY want to replace it with a new "
        msg$ = msg$ + "backup copy."
        Response = MsgBox(msg$, vbCritical + vbYesNo, "Warning !!!")
        If Response = vbYes Then
            Ensure_that_db_is_closed (DB_Path)
            Kill (DB_Path)
            Path_valid = True
        Else
            MsgBox "Backup proceedure aborted", vbInformation, "Backup"
            Path_valid = False
        End If
    Else
        Path_valid = True
    End If

End Function

Private Function Create_destination(DB_Path As String) As Boolean
    pnlProgress.Caption = "Creating destination database..."
    Set Backup_file = MyWorkspace.CreateDatabase _
                        (DB_Path, dbLangGeneral)
    Set Query = Backup_file.CreateQueryDef("Backup Query")
    Create_destination = True
    
End Function

Private Function Tables_copied_successfully(DB_Path As String) As Boolean

    Set Query = Transaction_db.QueryDefs("main query")
    
    If Not Copy_main_log(DB_Path) Then Exit Function
    If Not Copy_books_log(DB_Path) Then Exit Function
    If Not Copy_subscriber_log(DB_Path) Then Exit Function
    If Not Copy_users_log(DB_Path) Then Exit Function
    If Not Copy_setup_table(DB_Path) Then Exit Function
    Tables_copied_successfully = True
    
End Function

Private Function Copy_main_log(DB_Path As String) As Boolean
    
    pnlProgress.Caption = "Copying main log..."
    
    mySQL = "Select [Main log].* " _
          & "INTO [Backup Main Log]" _
          & "IN " + Quotes + DB_Path + Quotes + " " _
          & "FROM  [Main log]"
    
    Query.SQL = mySQL
    Query.Execute
    
    Set Main_log_table = Backup_file("Backup main log")
    
    Set Date_index = Main_log_table.CreateIndex("Date index")
    Set DateField = Date_index.CreateField("date")
    Date_index.Fields.Append DateField
    Main_log_table.Indexes.Append Date_index
    
    Set Book_number_index = Main_log_table.CreateIndex("Book number index")
    Set Bk_number = Book_number_index.CreateField("Book number")
    Book_number_index.Fields.Append Bk_number
    Main_log_table.Indexes.Append Book_number_index
        
    Set SubscriberID_index = Main_log_table.CreateIndex("Subscriber ID index")
    Set SubscriberID = SubscriberID_index.CreateField("Subscriber ID")
    SubscriberID_index.Fields.Append SubscriberID
    Main_log_table.Indexes.Append SubscriberID_index
        
    Copy_main_log = True
    
End Function

Private Function Copy_books_log(DB_Path) As Boolean
    
    pnlProgress.Caption = "Copying books log..."
    
    mySQL = "Select [Books log].* " _
          & "INTO [Backup Books Log]" _
          & "IN " + Quotes + DB_Path + Quotes + " " _
          & "FROM  [Books log]"
    
    Query.SQL = mySQL
    Query.Execute
    
    Backup_file.TableDefs.Refresh
    
    Set Books_log_table = Backup_file.TableDefs("Backup Books Log")
        
    Set Date_index = Books_log_table.CreateIndex("Date index")
    Set DateField = Date_index.CreateField("date")
    Date_index.Fields.Append DateField
    
    Set Book_number_index = Books_log_table.CreateIndex("Books number index")
    Set Bk_number = Date_index.CreateField("book number")
    Book_number_index.Fields.Append Bk_number
    
    Books_log_table.Indexes.Append Date_index
    Books_log_table.Indexes.Append Book_number_index
    
    Copy_books_log = True
    
End Function

Private Function Copy_subscriber_log(DB_Path As String) As Boolean
    
    pnlProgress.Caption = "Copying subscriber log..."
    
    mySQL = "Select [Subscriber log].* " _
          & "INTO [Backup Subscriber Log]" _
          & "IN " + Quotes + DB_Path + Quotes + " " _
          & "FROM  [Subscriber log]"
    
    Query.SQL = mySQL
    Query.Execute
        
    Backup_file.TableDefs.Refresh
    Set Subscriber_log_table = Backup_file.TableDefs("Backup subscriber log")
    
    Set Date_index = Subscriber_log_table.CreateIndex("Date index")
    Set DateField = Date_index.CreateField("date")
    Date_index.Fields.Append DateField
    Subscriber_log_table.Indexes.Append Date_index
    
    Set SubscriberID_index = Subscriber_log_table.CreateIndex("Subscriber ID index")
    Set SubscriberID = SubscriberID_index.CreateField("Subscriber ID")
    SubscriberID_index.Fields.Append SubscriberID
    Subscriber_log_table.Indexes.Append SubscriberID_index
    
    Copy_subscriber_log = True
    
End Function

Private Function Copy_users_log(DB_Path As String) As Boolean

    pnlProgress.Caption = "Copying users' log..."
    
    mySQL = "Select [User's log].* " _
          & "INTO [Backup User's Log]" _
          & "IN " + Quotes + DB_Path + Quotes + " " _
          & "FROM  [User's log]"
    
    Query.SQL = mySQL
    Query.Execute
    Copy_users_log = True
    
End Function

Private Function Copy_setup_table(DB_Path As String) As Boolean
    pnlProgress.Caption = "Copying setup table..."
    Set Query = Libra.QueryDefs("Query Obj")
    mySQL = "Select [Setup table].* " _
          & "INTO [Backup Setup table]" _
          & "IN " + Quotes + DB_Path + Quotes + " " _
          & "FROM  [Setup table]"

    
    Query.SQL = mySQL
    Query.Execute
    Copy_setup_table = True
    
End Function


Private Function Catalogue_built(DB_Path As String) As Boolean
    pnlProgress.Caption = "Building catalogue table..."
    Set Backup_file = Workspaces(0).OpenDatabase(DB_Path)
    Set Catalogue_table = Backup_file.CreateTableDef("Catalogue table")
    
    Set Identifier = Catalogue_table.CreateField("Identifier", dbText, 16)
    Set Variable = Catalogue_table.CreateField("Variable", dbDouble)
    
    Catalogue_table.Fields.Append Identifier
    Catalogue_table.Fields.Append Variable
    
    Set Catalogue_index = Catalogue_table.CreateIndex("Catalogue Index")
    Set Identifier = Catalogue_index.CreateField("Identifier")
    Catalogue_index.Fields.Append Identifier
    Catalogue_table.Indexes.Append Catalogue_index
    
    Backup_file.TableDefs.Append Catalogue_table
    DBEngine.Idle
    
    Define_catalogue_variables
    Call Register_catalogue_data("Created", Now)
    Call Register_catalogue_data("Book recs", Books_log.RecordCount)
    Call Register_catalogue_data("Subscriber recs", Subscriber_log.RecordCount)
    Call Register_catalogue_data("Users recs", User_log.RecordCount)
    Call Register_catalogue_data("Main recs", Main_log.RecordCount)
    Call Register_catalogue_data("Finish flag", True)
    
    DBEngine.Idle
    
    Catalogue_built = True
    
End Function

Private Sub Define_catalogue_variables()
    
    Set Catalogue = Backup_file.OpenRecordset("Catalogue table")
    Set Main_log = Backup_file.OpenRecordset("Backup Main log")
    Set Books_log = Backup_file.OpenRecordset("Backup Books log")
    Set Subscriber_log = Backup_file.OpenRecordset("Backup Subscriber log")
    Set User_log = Backup_file.OpenRecordset("Backup User's log")
    
    On Local Error Resume Next
    Main_log.MoveLast
    Books_log.MoveLast
    Subscriber_log.MoveLast
    User_log.MoveLast
    
End Sub

Private Sub Register_catalogue_data(Identifier As String, Variable As Double)

    Catalogue.AddNew
        Catalogue("Identifier") = Identifier
        Catalogue("Variable") = Variable
    Catalogue.Update

End Sub

Private Function Ensure_that_db_is_not_required_by_Libra(DB_Path As String) As Boolean
    Dim Main_DB_path As String
    Dim Working_DB_path As String
    Dim Tran_DB_path As String
    Dim msg As String
    
    Main_DB_path = Get_ini_data("Libra_db_path")
    Tran_DB_path = Get_ini_data("Transac_db_path")
    Working_DB_path = Get_ini_data("Working_path")
    
    If DB_Path = Main_DB_path Then
        msg = "main database"
    ElseIf DB_Path = Tran_DB_path Then
        msg = "transactions"
    ElseIf DB_Path = Working_DB_path Then
        msg = "working"
    End If
    
    If msg <> "" Then
        msg = "You cannot save you backup to the system's " + msg + " database."
        msg = msg + New_line + "Please change the path."
        MsgBox msg, vbCritical, "Critical System Enrichment"
        Ensure_that_db_is_not_required_by_Libra = False
    Else
        Ensure_that_db_is_not_required_by_Libra = True
    End If
    
End Function
        
    
Private Sub Ensure_that_db_is_closed(DB_Path As String)

    On Local Error Resume Next
    Backup_file.Close
    
End Sub

